import { Discriminator } from "../intrinsic-type-state.js";
import type { Program } from "../program.js";
import { Diagnostic, Model, Union } from "../types.js";
export interface DiscriminatedUnion {
    propertyName: string;
    variants: Map<string, Model>;
}
export declare function getDiscriminatedUnion(type: Model | Union, discriminator: Discriminator): [DiscriminatedUnion, readonly Diagnostic[]];
/**
 * Run the validation on all discriminated models to make sure the discriminator are valid.
 * This has to be done after the checker so we can have the full picture of all the dervied models.
 */
export declare function validateInheritanceDiscriminatedUnions(program: Program): void;
//# sourceMappingURL=discriminator-utils.d.ts.map