import type { Program, ProjectedProgram } from "../program.js";
import type { Type } from "../types.js";
export interface ProjectedNameView {
    program: ProjectedProgram;
    /**
     * Get the name of the given entity in that scope.
     * If there is a projected name it returns that one otherwise return the original name.
     */
    getProjectedName(target: Type & {
        name: string;
    }): string;
}
/**
 * Create an helper to manager project names.
 * @param program Program
 * @param target Name of the projected name target(e.g. json, csharp, etc.)
 * @returns ProjectedNameView
 */
export declare function createProjectedNameProgram(program: Program, target: string): ProjectedNameView;
//# sourceMappingURL=projected-names-utils.d.ts.map