import { spawn } from "child_process";
export async function installTypeSpecDependencies(host, directory) {
    const child = spawn("npm", ["install"], {
        shell: process.platform === "win32",
        stdio: "inherit",
        cwd: directory,
        env: process.env,
    });
    return new Promise(() => {
        child.on("error", (error) => {
            if (error.code === "ENOENT") {
                host.logger.error("Cannot find `npm` executable. Make sure to have npm installed in your path.");
            }
            else {
                host.logger.error(error.toString());
            }
            process.exit(error.errno);
        });
        child.on("exit", (exitCode) => {
            process.exit(exitCode ?? -1);
        });
    });
}
//# sourceMappingURL=install.js.map