/**
 * Keeps track of a value we don't know yet because of a circular reference. Use
 * the `onValue` method to provide a callback with how to handle the
 * placeholder's value becoming available. Generally the callback will replace
 * this placeholder with the value in whatever references the placeholder.
 */
export declare class Placeholder<T> {
    #private;
    setValue(value: T): void;
    onValue(cb: (value: T) => void): void;
}
//# sourceMappingURL=placeholder.d.ts.map