import { CompilerHost, Diagnostic, SourceFile } from "../core/types.js";
import { InitTemplate } from "./init-template.js";
export interface InitTypeSpecProjectOptions {
    templatesUrl?: string;
    template?: string;
}
export declare function initTypeSpecProject(host: CompilerHost, directory: string, options?: InitTypeSpecProjectOptions): Promise<void>;
export interface LoadedTemplate {
    readonly baseUri: string;
    readonly templates: Record<string, InitTemplate>;
    readonly file: SourceFile;
}
/**
 * Error thrown when init template acquisition fails or template is invalid.
 *
 * Contains diagnostics that can be logged to the user.
 */
export declare class InitTemplateError extends Error {
    diagnostics: readonly Diagnostic[];
    constructor(diagnostics: readonly Diagnostic[]);
}
//# sourceMappingURL=init.d.ts.map