import { setDocData } from "../core/intrinsic-type-state.js";
export const namespace = "TypeSpec";
const indexTypeKey = Symbol.for(`TypeSpec.index`);
export const $indexer = (context, target, key, value) => {
    const indexer = { key, value };
    context.program.stateMap(indexTypeKey).set(target, indexer);
};
export function getIndexer(program, target) {
    return program.stateMap(indexTypeKey).get(target);
}
/**
 * @internal to be used to set the `@doc` from doc comment.
 */
export const $docFromComment = (context, target, key, text) => {
    setDocData(context.program, target, key, { value: text, source: "comment" });
};
//# sourceMappingURL=intrinsic-decorators.js.map