import { CompilerOptions } from "../core/options.js";
import { BasicTestRunner, TestHost, TypeSpecTestLibrary, TypeSpecTestLibraryInit } from "./types.js";
export declare function resolveVirtualPath(path: string, ...paths: string[]): string;
/** Find the package root from the provided file */
export declare function findTestPackageRoot(fileUrl: string): Promise<string>;
/**
 * Define a test library defaulting to the most common library structure.
 * @param init Library configuration.
 * @returns TypeSpec Test library.
 */
export declare function createTestLibrary(init: TypeSpecTestLibraryInit): TypeSpecTestLibrary;
export interface TestWrapperOptions {
    wrapper?: (code: string) => string;
    /**
     * List of imports to include automatically.
     */
    autoImports?: string[];
    /**
     * List of usings to include automatically.
     */
    autoUsings?: string[];
    compilerOptions?: CompilerOptions;
}
export declare function createTestWrapper(host: TestHost, testWrapperOptions?: TestWrapperOptions): BasicTestRunner;
export declare function trimBlankLines(code: string): string;
//# sourceMappingURL=test-utils.d.ts.map